diff --git a/client/ifreload.c b/client/ifreload.c
index 8786cb3b8..77059906c 100644
--- a/client/ifreload.c
+++ b/client/ifreload.c
@@ -47,288 +47,114 @@
 #include "ifreload.h"
 #include "ifstatus.h"
 
-static ni_bool_t
-ifreload_mark_add(ni_ifworker_array_t *marked, ni_ifworker_t *w)
+static void
+ifreload_match_down(ni_fsm_t *fsm, ni_ifworker_array_t *ifmarked, const char *ifname)
 {
-	if (ni_ifworker_array_index(marked, w) != -1)
-		return FALSE;
-
-	ni_ifworker_array_append(marked, w);
-	return TRUE;
+	ni_ifmatcher_t ifmatch;
+
+	memset(&ifmatch, 0, sizeof(ifmatch));
+	ifmatch.allow_persistent = FALSE;
+	ifmatch.require_configured = TRUE;
+	ifmatch.require_config = FALSE;
+	ifmatch.ifreload = TRUE;
+	ifmatch.ifdown = TRUE;
+	ifmatch.name = ifname;
+
+	/* to shutdown if config changed + dependencies */
+	ni_fsm_get_matching_workers(fsm, &ifmatch, ifmarked);
 }
 
-static inline void
-ifreload_mark_down_lower_deps(const ni_fsm_t *fsm, ni_ifworker_array_t *marked, ni_ifworker_t *lower,
-				void (*logit)(const char *, ...) __fmtattr)
-{
-	ni_ifworker_t *w;
-	unsigned int i;
-
-	/* we need to shutdown also all depending worker devices c
-	 * that can't exist without w device (c->lowerdev == w) */
-	for (i = 0; i < fsm->workers.count; ++i) {
-		w = fsm->workers.data[i];
-
-		if (!w || w->lowerdev != lower)
-			continue;
-
-		if (ni_ifcheck_device_is_persistent(w->device)) {
-			logit("skipping %s shutdown: persistent mode is on", w->name);
-			continue;
-		}
-
-		w->target_range.min = NI_FSM_STATE_NONE;
-		w->target_range.max = NI_FSM_STATE_DEVICE_DOWN;
-
-		if (!ifreload_mark_add(marked, w))
-			continue;
-
-		ni_debug_ifconfig("marked %s for shutdown (config: %s, device: %s, target state %s) as dependency",
-				w->name,
-				ni_ifcheck_worker_config_exists(w) ? "exists" :
-				ni_ifcheck_device_configured(w->device) ? "deleted" : "-",
-				ni_ifcheck_worker_device_exists(w) ? "exists" : "-",
-				ni_ifworker_state_name(w->target_range.max));
-	}
-}
-
-static ni_bool_t
-ifreload_mark_down(const ni_fsm_t *fsm, ni_ifworker_array_t *marked, ni_ifworker_t *w,
-				void (*logit)(const char *, ...) __fmtattr,
-				unsigned int depth)
+static void
+ifreload_match_up(ni_fsm_t *fsm, ni_ifworker_array_t *ifmarked, const char *ifname)
 {
-	/* ifdown is disabled when persistent mode is on (todo: add --force?) */
-	if (ni_ifcheck_device_is_persistent(w->device)) {
-		logit("skipping %s shutdown: persistent mode is on", w->name);
-		return FALSE;
-	}
-
-	/* initialize as if the config would have been modified */
-	if (ni_ifcheck_worker_config_exists(w)) {
-		w->target_range.min = NI_FSM_STATE_NONE;
-		w->target_range.max = NI_FSM_STATE_DEVICE_READY;
-
-		/* the config has been modified, but some changes require deletion */
-		if (w->iftype == NI_IFTYPE_TEAM || w->iftype == NI_IFTYPE_VLAN) {
-			/* examples:
-			 *   - the team runner (mode) changes require teamd restart
-			 *   - VlanID changed, the interface need to be recreated */
-			w->target_range.max = NI_FSM_STATE_DEVICE_DOWN;
-		} else
-		if (w->iftype != NI_IFTYPE_UNKNOWN) {
-			/* if type changed, e.g. device is bond with bridge config */
-			if (w->device && w->device->link.type != w->iftype)
-				w->target_range.max = NI_FSM_STATE_DEVICE_DOWN;
-		}
-	} else
-	if (ni_ifcheck_device_configured(w->device)) {
-		/* config has been removed, so just delete it if applicable (=virtual) */
-		w->target_range.min = NI_FSM_STATE_NONE;
-		w->target_range.max = NI_FSM_STATE_DEVICE_DOWN;
-		ni_client_state_config_reset(&w->config.meta);
-	} else
-	if (!ni_ifcheck_worker_device_exists(w)) {
-		/* when the device does not exists, delete policy in nanny (if any) */
-		w->target_range.min = NI_FSM_STATE_NONE;
-		w->target_range.max = NI_FSM_STATE_DEVICE_DOWN;
-	} else {
-		/* do not shut down devices we don't handle */
-		logit("skipping %s shutdown: device was not configured by wicked", w->name);
-		return FALSE;
-	}
-
-	if (depth && ni_ifcheck_worker_device_exists(w)) {
-		ni_ifworker_t *c;
-		unsigned int i;
-
-		for (i = 0; i < fsm->workers.count; ++i) {
-			c = fsm->workers.data[i];
-
-			if (!ni_ifcheck_worker_device_exists(c))
-				continue;
-
-			if (!ni_string_eq(c->device->link.masterdev.name, w->name))
-				continue;
-
-			if (!ni_ifcheck_worker_config_matches(c)) {
-				ni_trace("exec ifreload_mark_workers down: %s", c->name);
-				ifreload_mark_down(fsm, marked, c, logit, depth - 1);
-			}
-		}
-	}
-
-	/* shut down depending devices because this one is deleted */
-	if (w->target_range.max == NI_FSM_STATE_DEVICE_DOWN)
-		ifreload_mark_down_lower_deps(fsm, marked, w, logit);
-
-	if (!ifreload_mark_add(marked, w))
-		return FALSE;
-
-	ni_debug_ifconfig("marked %s for shutdown (config: %s, device: %s, target state %s)",
-			w->name,
-			ni_ifcheck_worker_config_exists(w) ? "exists" :
-			ni_ifcheck_device_configured(w->device) ? "deleted" : "-",
-			ni_ifcheck_worker_device_exists(w) ? "exists" : "-",
-			ni_ifworker_state_name(w->target_range.max));
-
-	return TRUE;
+	ni_ifmatcher_t ifmatch;
+
+	memset(&ifmatch, 0, sizeof(ifmatch));
+	ifmatch.allow_persistent = TRUE;
+	ifmatch.require_configured = FALSE;
+	ifmatch.require_config = TRUE;
+	ifmatch.ifreload = TRUE;
+	ifmatch.ifdown = FALSE;
+	ifmatch.name = ifname;
+
+	/* to set-up if config changed + dependencies */
+	ni_fsm_get_matching_workers(fsm, &ifmatch, ifmarked);
 }
 
 static void
-ifreload_mark_up_slave_deps(const ni_fsm_t *fsm, ni_ifworker_array_t *marked, ni_ifworker_t *master,
-				void (*logit)(const char *, ...) __fmtattr)
+ifreload_match_workers(ni_fsm_t *fsm, ni_ifworker_array_t *down_marked,
+		ni_ifworker_array_t *up_marked, const char *ifname)
 {
-	ni_ifworker_t *w;
-	unsigned int i;
-
-	for (i = 0; i < fsm->workers.count; ++i) {
-		w = fsm->workers.data[i];
-
-		if (!w || w->masterdev != master)
-			continue;
-
-		if (!ni_ifcheck_worker_config_exists(w)) {
-			logit("skipping %s set-up: no configuration available", w->name);
-			continue;
-		}
-
-		if (!ifreload_mark_add(marked, w))
-			continue;
-
-		ni_debug_ifconfig("marked %s for set-up (config: %s, device: %s, target state %s) as dependency",
-				w->name,
-				(ni_ifcheck_worker_config_exists(w) ?
-				 (ni_ifcheck_worker_config_matches(w) ? "unchanged" : "modified") :
-				 (ni_ifcheck_device_configured(w->device) ? "deleted" : "-")),
-				(ni_ifcheck_worker_device_exists(w) ? "exists" : "-"),
-				ni_ifworker_state_name(w->target_range.max));
-	}
+	ifreload_match_down(fsm, down_marked, ifname);
+	ifreload_match_up(fsm, up_marked, ifname);
 }
 
 static void
-ifreload_mark_up_master(const ni_fsm_t *fsm, ni_ifworker_array_t *marked, ni_ifworker_t *w,
-				void (*logit)(const char *, ...) __fmtattr)
+ifreload_mark_worker_down(ni_fsm_t *fsm, ni_ifworker_array_t *down_marked, ni_ifworker_t *w)
 {
+	/* set default: try to go down without to delete it */
+	w->target_range.min = NI_FSM_STATE_NONE;
+	w->target_range.max = NI_FSM_STATE_DEVICE_READY;
+
+	/* when there is no config to apply, try to delete */
 	if (!ni_ifcheck_worker_config_exists(w)) {
-		logit("skipping %s set-up: no configuration available", w->name);
+		w->target_range.max = NI_FSM_STATE_DEVICE_DOWN;
 		return;
 	}
 
-	if (!ifreload_mark_add(marked, w))
+	/*
+	 * config and device type differs (e.g. bridge vs bond)
+	 */
+	if (w->iftype != NI_IFTYPE_UNKNOWN && w->device &&
+			w->device->link.type != w->iftype) {
+		w->target_range.max = NI_FSM_STATE_DEVICE_DOWN;
 		return;
-
-	ni_debug_ifconfig("marked %s for set-up (config %s, device %s, target state %s) as dependency",
-			w->name,
-			(ni_ifcheck_worker_config_exists(w) ?
-			 (ni_ifcheck_worker_config_matches(w) ? "unchanged" : "modified") :
-			 (ni_ifcheck_device_configured(w->device) ? "deleted" : "-")),
-			(ni_ifcheck_worker_device_exists(w) ? "exists" : "-"),
-			ni_ifworker_state_name(w->target_range.max));
-}
-
-static void
-ifreload_mark_up_lower_deps(const ni_fsm_t *fsm, ni_ifworker_array_t *marked, ni_ifworker_t *lower,
-				void (*logit)(const char *, ...) __fmtattr)
-{
-	ni_ifworker_t *w;
-	unsigned int i;
-
-	for (i = 0; i < fsm->workers.count; ++i) {
-		w = fsm->workers.data[i];
-
-		if (!w || w->lowerdev != lower)
-			continue;
-
-		if (!ni_ifcheck_worker_config_exists(w)) {
-			logit("skipping %s set-up: no configuration available", w->name);
-			continue;
-		}
-
-		/* e.g. a vlan [w] can't exist without it's lowerdev [l]
-		 * and is deleted as dependency to deletion of lower [l].
-		 * for now, we need to trigger set-up of it's master [m]
-		 * (team0 [l] <-lower- team0.42 [w] -master-> [m] br42)
-		 * to ensure it gets (re-)enslaved into it.
-		 */
-		if (w->masterdev)
-			ifreload_mark_up_master(fsm, marked, w->masterdev, logit);
-
-		if (!ifreload_mark_add(marked, w))
-			continue;
-
-		ni_debug_ifconfig("marked %s for set-up (config %s, device %s, target state %s) as dependency",
-				w->name,
-				(ni_ifcheck_worker_config_exists(w) ?
-				 (ni_ifcheck_worker_config_matches(w) ? "unchanged" : "modified") :
-				 (ni_ifcheck_device_configured(w->device) ? "deleted" : "-")),
-				(ni_ifcheck_worker_device_exists(w) ? "exists" : "-"),
-				ni_ifworker_state_name(w->target_range.max));
 	}
-}
 
-static ni_bool_t
-ifreload_mark_up(const ni_fsm_t *fsm, ni_ifworker_array_t *marked, ni_ifworker_t *w,
-				void (*logit)(const char *, ...) __fmtattr)
-{
-	if (!ni_ifcheck_worker_config_exists(w)) {
-		logit("skipping %s set-up: no configuration available", w->name);
-		return FALSE;
+	/*
+	 * link config may have changed what may require deletion
+	 */
+	switch (w->iftype) {
+	case NI_IFTYPE_PPP:
+	case NI_IFTYPE_TEAM:
+	case NI_IFTYPE_VLAN:
+		/*
+		 * - ppp,team config file changes require service restart
+		 * - vlan id changed
+		 */
+		w->target_range.max = NI_FSM_STATE_DEVICE_DOWN;
+		return;
+	default:
+		break;
 	}
-
-	/* trigger set-up for slaves to (re-)enslave them */
-	ifreload_mark_up_slave_deps(fsm, marked, w, logit);
-
-	/* trigger set-up for devices we're base / lower
-	 * for as they can't exists without their base */
-	ifreload_mark_up_lower_deps(fsm, marked, w, logit);
-
-	if (!ifreload_mark_add(marked, w))
-		return FALSE;
-
-	ni_debug_ifconfig("marked %s for set-up (config %s, device %s, target state %s)",
-			w->name,
-			(ni_ifcheck_worker_config_exists(w) ?
-			 (ni_ifcheck_worker_config_matches(w) ? "unchanged" : "modified") :
-			 (ni_ifcheck_device_configured(w->device) ? "deleted" : "-")),
-			(ni_ifcheck_worker_device_exists(w) ? "exists" : "-"),
-			ni_ifworker_state_name(w->target_range.max));
-
-	return TRUE;
 }
 
 static void
-ifreload_mark_workers(const ni_fsm_t *fsm, ni_ifworker_array_t *down_marked, ni_ifworker_array_t *up_marked, const char *ifname)
+ifreload_mark_workers_down(ni_fsm_t *fsm, ni_ifworker_array_t *ifmarked)
 {
-	void (*logit)(const char *, ...) __fmtattr = ifname ? ni_note : ni_info;
 	ni_ifworker_t *w;
 	unsigned int i;
 
-	/* shutdown if config changed + dependencies */
-	for (i = 0; i < fsm->workers.count; ++i) {
-		w = fsm->workers.data[i];
-
+	/* init the shutdown / deletion targets */
+	for (i = 0; i < ifmarked->count; ++i) {
+		w = ifmarked->data[i];
 		if (w->type != NI_IFWORKER_TYPE_NETDEV)
 			continue;
 
-		if (ifname && !ni_string_eq(w->name, ifname))
-			continue;
-
-		if (!ni_ifcheck_worker_config_matches(w))
-			ifreload_mark_down(fsm, down_marked, w, logit, 1);
+		ifreload_mark_worker_down(fsm, ifmarked, w);
 	}
-
-	/* set-up if config changed + dependencies */
-	for (i = 0; i < fsm->workers.count; ++i) {
-		w = fsm->workers.data[i];
+	/* second pass: check lower changes */
+	for (i = 0; i < ifmarked->count; ++i) {
+		w = ifmarked->data[i];
 
 		if (w->type != NI_IFWORKER_TYPE_NETDEV)
 			continue;
 
-		if (ifname && !ni_string_eq(w->name, ifname))
+		if (!w->lowerdev)
 			continue;
 
-		if (!ni_ifcheck_worker_config_matches(w))
-			ifreload_mark_up(fsm, up_marked, w, logit);
+		if (w->lowerdev->target_range.max == NI_FSM_STATE_DEVICE_DOWN)
+			w->target_range.max = NI_FSM_STATE_DEVICE_DOWN;
 	}
 }
 
@@ -343,6 +169,7 @@ ni_do_ifreload(const char *caller, int argc, char **argv)
 		OPT_TRANSIENT	= 'T',
 		OPT_RELEASE,
 		OPT_NO_RELEASE,
+		OPT_DRY_RUN,
 	};
 	static struct option ifreload_options[] = {
 		{ "help",		no_argument,		NULL,	OPT_HELP },
@@ -352,6 +179,7 @@ ni_do_ifreload(const char *caller, int argc, char **argv)
 		{ "persistent",		no_argument,		NULL,	OPT_PERSISTENT },
 		{ "release",		no_argument,		NULL,	OPT_RELEASE },
 		{ "no-release",		no_argument,		NULL,	OPT_NO_RELEASE },
+		{ "dry-run",		no_argument,		NULL,	OPT_DRY_RUN },
 
 		{ NULL,			no_argument,		NULL,	0 }
 	};
@@ -363,6 +191,7 @@ ni_do_ifreload(const char *caller, int argc, char **argv)
 	ni_bool_t opt_persistent = FALSE;
 	ni_bool_t opt_transient = FALSE;
 	ni_tristate_t opt_release = NI_TRISTATE_DEFAULT;
+	ni_log_fn_t *dry_run = NULL;
 	unsigned int seconds = 0;
 	int c, status = NI_WICKED_RC_USAGE;
 	char *saved_argv0, *program = NULL;
@@ -408,6 +237,10 @@ ni_do_ifreload(const char *caller, int argc, char **argv)
 			opt_release = NI_TRISTATE_DISABLE;
 			break;
 
+		case OPT_DRY_RUN:
+			dry_run = ni_note;
+			break;
+
 		default:
 		case OPT_HELP:
 usage:
@@ -426,6 +259,8 @@ usage:
 				"      Set interface into persistent mode (no regular ifdown allowed)\n"
 				"  --[no-]release\n"
 				"      Override active config to (not) release leases in ifdown\n"
+				"  --dry-run\n"
+				"      Show interface hierarchies as notice with (+/-) markers and exit.\n"
 				, program);
 			goto cleanup;
 		}
@@ -491,23 +326,28 @@ usage:
 
 	/* Build the up a config relations/hierarchy tree */
 	if (ni_fsm_build_hierarchy(fsm, FALSE) < 0) {
-		ni_error("ifreload: unable to build device config hierarchy");
+		ni_error("ifreload: unable to build interface hierarchy");
 		/* Severe error we always explicitly return */
 		status = NI_WICKED_RC_ERROR;
 		goto cleanup;
 	}
 
+	/* Get workers that match given criteria */
 	status = NI_WICKED_RC_SUCCESS;
 	for (c = optind; c < argc; ++c) {
 		const char *ifname = argv[c];
 
 		if (ni_string_eq(ifname, "all") || ni_string_empty(ifname)) {
-			ifreload_mark_workers(fsm, &down_marked, &up_marked, NULL);
+			ifreload_match_workers(fsm, &down_marked, &up_marked, NULL);
 			break;
 		} else {
-			ifreload_mark_workers(fsm, &down_marked, &up_marked, ifname);
+			ifreload_match_workers(fsm, &down_marked, &up_marked, ifname);
 		}
 	}
+	ni_fsm_print_system_hierarchy(fsm, &down_marked, dry_run);
+	ni_fsm_print_config_hierarchy(fsm, &up_marked, dry_run);
+	if (dry_run)
+		goto cleanup;
 
 	if (opt_persistent) {
 		for (i = 0; i < up_marked.count; ++i) {
@@ -534,6 +374,8 @@ usage:
 		/* Run ifdown part of the reload */
 		ni_debug_application("Shutting down unneeded devices");
 
+		ifreload_mark_workers_down(fsm, &down_marked);
+
 		/* delete policies */
 		ni_ifdown_fire_nanny(&down_marked);
 
@@ -571,8 +413,6 @@ usage:
 		goto cleanup;
 	}
 
-	ni_fsm_pull_in_children(&up_marked, fsm);
-
 	/* anything to ifup? */
 	if (up_marked.count) {
 		if (!(monitor = ni_nanny_fsm_monitor_new(fsm))) {
diff --git a/client/ifup.c b/client/ifup.c
index 45dcc37e2..641e31f5d 100644
--- a/client/ifup.c
+++ b/client/ifup.c
@@ -53,110 +53,120 @@ struct ni_nanny_fsm_monitor {
 	ni_ifworker_array_t *	marked;
 };
 
-static xml_node_t *
-__ni_ifup_generate_match_dev(xml_node_t *node, ni_ifworker_t *w)
-{
-	if (!node || !w || ni_string_empty(w->name))
-		return NULL;
-	return xml_node_new_element(NI_NANNY_IFPOLICY_MATCH_DEV, node, w->name);
-}
-
 static ni_bool_t
-__ni_ifup_generate_match_link_port_ref(xml_node_t *match, xml_node_t *port)
+ni_ifup_generate_match_device(xml_node_t *node, ni_ifworker_t *w)
 {
-	const char *type = xml_node_get_attr(port, NI_CLIENT_IFCONFIG_PORT_TYPE);
-	ni_iftype_t ptype = ni_linktype_name_to_type(type);
-	xml_node_t *ref, *ovsbr;
-
-	switch (ptype) {
-	case NI_IFTYPE_OVS_BRIDGE:
-		ovsbr = xml_node_get_child(port, NI_CLIENT_IFCONFIG_BRIDGE);
-		if (!ovsbr || ni_string_empty(ovsbr->cdata))
-			return FALSE;
-
-		if (!(ref = xml_node_new(NI_NANNY_IFPOLICY_MATCH_REF, match)))
-			return FALSE;
-
-		if (!xml_node_new_element(NI_NANNY_IFPOLICY_MATCH_DEV, ref, ovsbr->cdata)) {
-			xml_node_free(ref);
-			return FALSE;
-		}
-		break;
+	/*
+	 * Generate <device>${w->name}</device> match (self reference) node.
+	 */
+	if (!node || !w || ni_string_empty(w->name))
+		return FALSE;
 
-	default:
-		/* other port types need master only */
-		break;
-	}
-	return TRUE;
+	return !!xml_node_new_element(NI_NANNY_IFPOLICY_MATCH_DEV, node, w->name);
 }
 
 static ni_bool_t
-__ni_ifup_generate_match_link_ref(xml_node_t *match, xml_node_t *link)
+ni_ifup_generate_match_device_ref(xml_node_t *match, const char *name)
 {
-	xml_node_t *ref, *master, *port;
-
-	if (!(master = xml_node_get_child(link, NI_CLIENT_IFCONFIG_MASTER)))
-		return TRUE; /* <link> does not contain a <master> node */
-
-	if (ni_string_empty(master->cdata))
-		return FALSE;
-
-	if (ni_string_eq(master->cdata, ni_linktype_type_to_name(NI_IFTYPE_OVS_SYSTEM))) {
-		if ((port = xml_node_get_child(link, NI_CLIENT_IFCONFIG_LINK_PORT)))
-			return __ni_ifup_generate_match_link_port_ref(match, port);
+	xml_node_t *ref;
 
+	/*
+	 * Generate <reference><device>${name}</device></reference>
+	 * match node to a related (lower, master, …) interface name.
+	 */
+	if (!match || ni_string_empty(name))
 		return FALSE;
-	}
 
 	if (!(ref = xml_node_new(NI_NANNY_IFPOLICY_MATCH_REF, match)))
 		return FALSE;
 
-	if (!xml_node_new_element(NI_NANNY_IFPOLICY_MATCH_DEV, ref, master->cdata)) {
-		xml_node_free(ref);
-		return FALSE;
-	}
+	if (xml_node_new_element(NI_NANNY_IFPOLICY_MATCH_DEV, ref, name))
+		return TRUE;
 
-	if ((port = xml_node_get_child(link, NI_CLIENT_IFCONFIG_LINK_PORT)))
-		return __ni_ifup_generate_match_link_port_ref(match, port);
-
-	return TRUE; /* master ref at least */
+	xml_node_detach(ref);
+	xml_node_free(ref);
+	return FALSE;
 }
 
 static ni_bool_t
-__ni_ifup_generate_match_master_ref(xml_node_t *match, ni_ifworker_t *master)
+ni_ifup_generate_match_lower_ref(xml_node_t *match, ni_ifworker_t *w)
 {
-	xml_node_t *ref;
-
-	if (!master || ni_string_empty(master->name))
-		return FALSE;
+	/*
+	 * If we have a lower/underlying interface (e.g. lower=bond0)
+	 * reference and our (e.g. vlan bond0.42) interface can't
+	 * be setup or even can't be created or exist without it,
+	 * e.g.:
+	 *     ip link add dev bond0.42 link bond0 type vlan id 42
+	 *
+	 * In the config, the lower reference does not have a fix
+	 * node name, but is provided by type specific nodes, e.g.
+	 * for vlan|macvlan:
+	 *     <vlan|macvlan|…>
+	 *       <device>${w->lowerdev}</device>
+	 *     </vlan|macvlan|…>
+	 * for ovs vlan (fake) bridge's parent bridge:
+	 *     <ovs-bridge>
+	 *       <vlan>
+	 *         <parent>${w->lowerdev}</device>
+	 *       </vlan>
+	 *     </ovs-bridge>
+	 *
+	 * The w->lowerdev points to the worker resolved from the
+	 * config by fsm while (config) hierarchy build, so we
+	 * don't need to "find it manually".
+	 */
+	if (!w->lowerdev)
+		return TRUE;
 
-	if (!(ref = xml_node_new(NI_NANNY_IFPOLICY_MATCH_REF, match)))
-		return FALSE;
+	return ni_ifup_generate_match_device_ref(match, w->lowerdev->name);
+}
 
-	if (!xml_node_new_element(NI_NANNY_IFPOLICY_MATCH_DEV, ref, master->name)) {
-		xml_node_free(ref);
-		return FALSE;
-	}
+static ni_bool_t
+ni_ifup_generate_match_master_ref(xml_node_t *match, ni_ifworker_t *w)
+{
+	/*
+	 * If we are a port (e.g. bond0.42 vlan) bound to a master
+	 * (e.g. br42 bridge) required for the link setup, e.g.:
+	 *     ip link set dev bond0.42 master br42
+	 *
+	 * The <link> node provides a typed port union:
+	 *   <link>
+	 *     <master>${w->masterdev}</master>
+	 *     <port type="${type-name}">${type-data}</port>
+	 *   </link>
+	 *
+	 * The port type is the type of the effective master and
+	 * its content is type specific port configuration node.
+	 *
+	 * The w->masterdev points to the worker resolved from the
+	 * config by fsm while (config) hierarchy build, so we
+	 * don't need to "find it manually".
+	 */
+	if (!w->masterdev)
+		return TRUE;
 
-	return TRUE;
+	return ni_ifup_generate_match_device_ref(match, w->masterdev->name);
 }
 
 static ni_bool_t
-__ni_ifup_generate_match_refs(xml_node_t *match, ni_ifworker_t *w)
+ni_ifup_generate_match_refs(xml_node_t *match, ni_ifworker_t *w)
 {
-	xml_node_t *link;
-
-	if (w->masterdev)
-		return __ni_ifup_generate_match_master_ref(match, w->masterdev);
+	/*
+	 * Some interface types may have a lower (underlying)
+	 * interface and (most) can be also bound as port to
+	 * an another master reference.
+	 */
+	if (!ni_ifup_generate_match_lower_ref(match, w))
+		return FALSE;
 
-	if ((link = xml_node_get_child(w->config.node, NI_CLIENT_IFCONFIG_LINK)))
-		return __ni_ifup_generate_match_link_ref(match, link);
+	if (!ni_ifup_generate_match_master_ref(match, w))
+		return FALSE;
 
-	return TRUE; /* no refs is not an error */
+	return TRUE; /* no refa is not an error */
 }
 
 static xml_node_t *
-__ni_ifup_generate_match(const char *name, ni_ifworker_t *w)
+ni_ifup_generate_match(const char *name, ni_ifworker_t *w)
 {
 	xml_node_t *match;
 
@@ -167,47 +177,27 @@ __ni_ifup_generate_match(const char *name, ni_ifworker_t *w)
 		"generate policy match for %s (type %s)", w->name,
 		ni_linktype_type_to_name(w->iftype));
 
-	if (!__ni_ifup_generate_match_dev(match, w))
+	if (!ni_ifup_generate_match_device(match, w)) {
+		ni_error("%s: unable to generate policy device match",
+				w->name);
 		goto error;
+	}
 
-	/* Ignore child dependency for following device types:
-	 *  - ovs-system: otherwise ovs-system would require all ports
-	 *    in all ovs-bridges and want to get at least one up ...
-	 *    this is not what we want :-)
+	/*
+	 * The ovs-system datapath does not have any
+	 * (should not have any) references to other
+	 * interfaces...
 	 */
-	switch (w->iftype) {
-	case NI_IFTYPE_OVS_SYSTEM:
+	if (w->iftype == NI_IFTYPE_OVS_SYSTEM ||
+	    ni_string_eq(w->name, ni_linktype_type_to_name(NI_IFTYPE_OVS_SYSTEM)))
 		goto done;
-		break;
-	default:
-		if (ni_string_eq(w->name, ni_linktype_type_to_name(NI_IFTYPE_OVS_SYSTEM)))
-			goto done;
-		break;
-	}
 
-	if (!__ni_ifup_generate_match_refs(match, w)) {
-		ni_debug_application("%s: unable to generate policy match device references",
+	if (!ni_ifup_generate_match_refs(match, w)) {
+		ni_error("%s: unable to generate policy device reference match",
 				w->name);
 		goto error;
 	}
 
-	if (w->children.count) {
-		xml_node_t *or;
-		unsigned int i;
-
-		if (!(or = xml_node_new(NI_NANNY_IFPOLICY_MATCH_COND_OR, match)))
-			goto error;
-
-		for (i = 0; i < w->children.count; i++) {
-			ni_ifworker_t *child = w->children.data[i];
-			xml_node_t *cnode;
-
-			cnode = xml_node_new(NI_NANNY_IFPOLICY_MATCH_COND_CHILD, or);
-			if (!cnode || !__ni_ifup_generate_match_dev(cnode, child))
-				goto error;
-		}
-	}
-
 done:
 	return match;
 error:
@@ -227,7 +217,7 @@ ni_ifup_start_policy(ni_ifworker_t *w)
 
 	ni_debug_application("%s: hiring nanny", w->name);
 
-	match = __ni_ifup_generate_match(NI_NANNY_IFPOLICY_MATCH, w);
+	match = ni_ifup_generate_match(NI_NANNY_IFPOLICY_MATCH, w);
 	if (!match)
 		goto error;
 
@@ -455,6 +445,7 @@ ni_do_ifup(int argc, char **argv)
 {
 	enum  { OPT_HELP, OPT_IFCONFIG, OPT_CONTROL_MODE, OPT_STAGE, OPT_TIMEOUT,
 		OPT_SKIP_ACTIVE, OPT_SKIP_ORIGIN, OPT_PERSISTENT, OPT_TRANSIENT,
+		OPT_DRY_RUN,
 #ifdef NI_TEST_HACKS
 		OPT_IGNORE_PRIO, OPT_IGNORE_STARTMODE,
 #endif
@@ -474,6 +465,7 @@ ni_do_ifup(int argc, char **argv)
 		{ "ignore-startmode",no_argument, NULL,	OPT_IGNORE_STARTMODE },
 #endif
 		{ "persistent",	no_argument, NULL,	OPT_PERSISTENT },
+		{ "dry-run",	no_argument, NULL,	OPT_DRY_RUN },
 		{ NULL }
 	};
 
@@ -484,6 +476,7 @@ ni_do_ifup(int argc, char **argv)
 	ni_string_array_t ifnames = NI_STRING_ARRAY_INIT;
 	ni_bool_t check_prio = TRUE, set_persistent = FALSE;
 	ni_bool_t opt_transient = FALSE;
+	ni_log_fn_t *dry_run = NULL;
 	int c, status = NI_WICKED_RC_USAGE;
 	unsigned int seconds = 0;
 	ni_fsm_t *fsm;
@@ -538,12 +531,16 @@ ni_do_ifup(int argc, char **argv)
 			break;
 #endif
 
+		case OPT_TRANSIENT:
+			opt_transient = TRUE;
+			break;
+
 		case OPT_PERSISTENT:
 			set_persistent = TRUE;
 			break;
 
-		case OPT_TRANSIENT:
-			opt_transient = TRUE;
+		case OPT_DRY_RUN:
+			dry_run = ni_note;
 			break;
 
 		default:
@@ -578,6 +575,8 @@ usage:
 #endif
 				"  --persistent\n"
 				"      Set interface into persistent mode (no regular ifdown allowed)\n"
+				"  --dry-run\n"
+				"      Show interface hierarchies as notice with (+) markers and exit.\n"
 				);
 			goto cleanup;
 		}
@@ -633,15 +632,14 @@ usage:
 	ni_nanny_fsm_monitor_arm(monitor, fsm->worker_timeout);
 
 	if (ni_fsm_build_hierarchy(fsm, TRUE) < 0) {
-		ni_error("ifup: unable to build device hierarchy");
+		ni_error("ifup: unable to build interface hierarchy");
 		/* Severe error we always explicitly return */
 		status = NI_WICKED_RC_ERROR;
 		goto cleanup;
 	}
 
-	status = NI_WICKED_RC_SUCCESS;
-
 	/* Get workers that match given criteria */
+	status = NI_WICKED_RC_SUCCESS;
 	while (optind < argc) {
 		ifmatch.name = argv[optind++];
 
@@ -662,7 +660,10 @@ usage:
 			ni_string_array_append(&ifnames, ifmatch.name);
 	}
 
-	ni_fsm_pull_in_children(&ifmarked, fsm);
+	ni_fsm_print_system_hierarchy(fsm, NULL, dry_run);
+	ni_fsm_print_config_hierarchy(fsm, &ifmarked, dry_run);
+	if (dry_run)
+		goto cleanup;
 
 	if (!ni_ifup_hire_nanny(&ifmarked, set_persistent))
 		status = NI_WICKED_RC_NOT_CONFIGURED;
diff --git a/client/nanny.c b/client/nanny.c
index 17a7f2142..4e3306c33 100644
--- a/client/nanny.c
+++ b/client/nanny.c
@@ -305,7 +305,7 @@ ni_nanny_addpolicy_node(const xml_node_t *pnode, const char *origin)
 int
 ni_nanny_addpolicy(xml_document_t *doc)
 {
-	xml_node_t *root, *pnode;
+	xml_node_t *root;
 	const char *origin;
 	int count = 0;
 
@@ -320,16 +320,7 @@ ni_nanny_addpolicy(xml_document_t *doc)
 			NI_CLIENT_IFCONFIG, origin, NI_NANNY_IFPOLICY);
 		return -1;
 	}
-
-	for (pnode = root->children; pnode; pnode = pnode->next) {
-		int rv = ni_nanny_addpolicy_node(pnode, origin);
-		if (rv < 0)
-			return rv;
-
-		count += rv;
-	}
-
-	return count;
+	return ni_nanny_addpolicy_node(xml_document_root(doc), origin);
 }
 
 /*
diff --git a/client/read-config.c b/client/read-config.c
index 097a46802..9c7ee2858 100644
--- a/client/read-config.c
+++ b/client/read-config.c
@@ -279,17 +279,17 @@ ni_ifconfig_load(ni_fsm_t *fsm, const char *root, ni_string_array_t *opt_ifconfi
 			return FALSE;
 		}
 	}
+	if (ni_ifxml_migrate_docs(&docs))
+		ni_debug_readwrite("Migrated configuration to current schema");
 
 	for (i = 0; i < docs.count; i++) {
-		xml_node_t *root, *ifnode;
+		xml_node_t *root;
 		const char *origin;
 
 		root = xml_document_root(docs.data[i]);
 		origin = xml_node_location_filename(root);
-		for (ifnode = root->children; ifnode; ifnode = ifnode->next) {
-			/* We do not fail when unable to generate ifworker */
-			ni_fsm_workers_from_xml(fsm, ifnode, origin);
-		}
+		/* We do not fail when unable to generate ifworker */
+		ni_fsm_workers_from_xml(fsm, root, origin);
 	}
 
 	xml_document_array_destroy(&docs);
@@ -415,8 +415,11 @@ ni_ifconfig_validate_adding_doc(xml_document_t *config_doc, ni_bool_t check_prio
 	src_root = xml_document_root(config_doc);
 	src_prio = ni_ifconfig_origin_get_prio(xml_node_location_filename(src_root));
 
-	/* Go through all config_doc's <interfaces> */
-	for (src_child = src_root->children; src_child; src_child = src_child->next) {
+	if (ni_string_empty(src_root->name))
+		src_child = src_root->children;
+	else
+		src_child = src_root;
+	for ( ; src_child; src_child = src_child->next) {
 		int rv;
 
 		if (ni_ifconfig_is_policy(src_child)) {
@@ -489,8 +492,6 @@ ni_ifconfig_read_wicked_xml_file(xml_document_array_t *docs,
 
 		xml_node_location_set(node, xml_location_clone(cnode->location));
 		xml_node_reparent(node, cnode);
-		if (ni_ifconfig_migrate(node))
-			ni_debug_readwrite("Migrated \"%s\" config to current schema", conf.origin);
 
 		ni_ifconfig_metadata_clear(node);
 		if (!raw)
@@ -498,10 +499,11 @@ ni_ifconfig_read_wicked_xml_file(xml_document_array_t *docs,
 
 		if (ni_ifconfig_validate_adding_doc(doc, check_prio)) {
 			ni_debug_ifconfig("%s: %s", __func__, xml_node_location(node));
-			xml_document_array_append(docs, doc);
-		} else {
-			xml_document_free(doc);
+
+			if (xml_document_expand(docs, doc))
+				continue;
 		}
+		xml_document_free(doc);
 	}
 
 	ni_client_state_config_reset(&conf);
@@ -699,10 +701,10 @@ ni_ifconfig_read_firmware(xml_document_array_t *array,
 
 			if (ni_ifconfig_validate_adding_doc(config, check_prio)) {
 				ni_debug_ifconfig("%s: %s", __func__, xml_node_location(node));
-				xml_document_array_append(array, config);
-			} else {
-				xml_document_free(config);
+				if (xml_document_expand(array, config))
+					continue;
 			}
+			xml_document_free(config);
 		}
 	}
 
@@ -732,7 +734,11 @@ ni_ifconfig_metadata_add_to_node(xml_node_t *root, ni_client_state_config_t *con
 	if (!root || !root->children || !conf || ni_string_empty(conf->origin))
 		return;
 
-	while ((ifnode = xml_node_get_next_child(root, root->children->name, ifnode))) {
+	if (ni_string_empty(root->name))
+		ifnode = root->children;
+	else
+		ifnode = root;
+	for ( ; ifnode; ifnode = ifnode->next) {
 		xml_node_add_attr(ifnode,
 				NI_CLIENT_STATE_XML_CONFIG_ORIGIN_NODE,
 					conf->origin);
@@ -759,7 +765,11 @@ ni_ifconfig_metadata_get_from_node(ni_client_state_config_t *conf, xml_node_t *r
 		return FALSE;
 
 	ni_client_state_config_reset(conf);
-	while ((ifnode = xml_node_get_next_child(root, root->children->name, ifnode))) {
+	if (ni_string_empty(root->name))
+		ifnode = root->children;
+	else
+		ifnode = root;
+	for ( ; ifnode; ifnode = ifnode->next) {
 		/* only first   node with proper meta data attributes is processed */
 		const char *origin;
 		const char *str;
@@ -790,7 +800,11 @@ ni_ifconfig_metadata_clear(xml_node_t *root)
 	if (!root || !root->children)
 		return;
 
-	while ((ifnode = xml_node_get_next_child(root, root->children->name, ifnode))) {
+	if (ni_string_empty(root->name))
+		ifnode = root->children;
+	else
+		ifnode = root;
+	for ( ; ifnode; ifnode = ifnode->next) {
 		xml_node_del_attr(ifnode, NI_CLIENT_STATE_XML_CONFIG_ORIGIN_NODE);
 		xml_node_del_attr(ifnode, NI_CLIENT_STATE_XML_CONFIG_UUID_NODE);
 		xml_node_del_attr(ifnode, NI_CLIENT_STATE_XML_CONFIG_OWNER_NODE);
